const through = require('through2')
const path = require('path')

function inject(file, params) {
  const {
    contents,
    pathes,
    cwd
  } = params
  let originalContents = String(file.contents)
  let outputContents = originalContents
  if (pathes instanceof Array && pathes.length) {
    pathes.forEach(filePath => {
      if (cwd) {
        filePath = path.resolve(cwd, filePath)
      }
      outputContents = `@import '${filePath}';\n` + outputContents
    })
  }
  if (contents) {
    outputContents = contents + outputContents
  }
  file.contents = Buffer.from(outputContents)
  return file
}

module.exports = function (params) {
  return through.obj(function (file, encoding, callback) {
    let newFile = null
    let err = null
    try {
      newFile = inject(file, params)
    } catch (e) {
      err = e
    }
    callback(err, newFile)
  })
}
